<template>
  <div>
      <el-breadcrumb separator-class="el-icon-arrow-right">
        <el-breadcrumb-item :to="{ path: '/home' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>权限管理</el-breadcrumb-item>
        <el-breadcrumb-item>角色列表</el-breadcrumb-item>
      </el-breadcrumb>

      <el-card>
          <el-row>
              <el-col>
                  <el-button 
                  type="primary"
                  @click="dialogVisible = true"
                  >添加角色</el-button>
              </el-col>
          </el-row>
        
        <el-table
            :data="rolesList"
            style="width: 100%">
            <!-- 展开列 -->
            <el-table-column type="expand">
                <template slot-scope="scope">
                    <el-row
                    :class="['bdbottom',i1 === 0? 'bdtop':'','vcenter']"
                     v-for="(item1, i1) in scope.row.children"
                    :key="item1.id">
                        <!-- 一级权限 -->
                        <el-col :span="5"
                        class="el-col1">
                            <el-tag
                            closable
                            @close="removeById(scope.row, item1.id)">
                                {{item1.authName}}
                            </el-tag>
                            <i class="el-icon-caret-right"></i>
                        </el-col>
                        <!-- 二级三级权限 -->
                        <el-col :span="19">
                            <!-- for循环渲染二级权限 -->
                            <el-col>
                                <el-row 
                                :class="[i2 === 0? '':'bdtop','vcenter']"
                                v-for="(item2, i2) in item1.children"
                                :key="item2.id">
                                    <!-- 二级权限 -->
                                    <el-col :span="6">
                                        <el-tag 
                                        type="success"
                                        closable
                                        @close="removeById(scope.row, item2.id)">
                                            {{item2.authName}}
                                        </el-tag>
                                        <i class="el-icon-caret-right"></i>
                                    </el-col>
                                    <!-- 三级权限 -->
                                    <el-col 
                                    :span="18">
                                        <el-tag
                                        type="warning"
                                        v-for="(item3,i3) in item2.children"
                                        :key="item3.id"
                                        closable
                                        @close="removeById(scope.row, item3.id)">
                                            {{item3.authName}}
                                        </el-tag>
                                    </el-col>
                                </el-row>
                            </el-col>
                        </el-col>
                    </el-row>
                </template>
            </el-table-column>
            <!-- 索引列 -->
            <el-table-column
                type="index"
                label="#"
                width="180">
            </el-table-column>
            <el-table-column
                prop="roleName"
                label="角色名称"
                width="180">
            </el-table-column>
            <el-table-column
                prop="roleDesc"
                label="角色描述"
                width="180">
            </el-table-column>
            <el-table-column
                prop="address"
                label="操作">
                <template slot-scope="scope">
                    <!-- 修改按钮 -->
                        <el-button 
                        type="primary" 
                        icon="el-icon-edit" 
                        size="mini"
                        @click="showUserFrom(scope.row.id)"
                        >编辑</el-button>
                    <!-- 删除按钮 -->
                        <el-button 
                        type="danger" 
                        icon="el-icon-delete" 
                        size="mini"
                        @click="removeUser(scope.row.id)"
                        >删除</el-button>
                    <!-- 角色分配按钮 -->
                        <el-button 
                        type="warning" 
                        icon="el-icon-help" 
                        size="mini"
                        @click="setRightDialogV(scope.row)"
                        >分配权限
                        </el-button>
                </template>
            </el-table-column>
        </el-table>
      </el-card>

      <!-- 分页 -->
        <!-- <el-pagination
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"
            :current-page="queryInfo.pagenum"
            :page-sizes="[2, 5, 10, 15]"
            :page-size="queryInfo.pagesize"
            layout="total, sizes, prev, pager, next, jumper"
            :total="total"
            >
        </el-pagination> -->

      <!-- 弹框组件 -->
        <el-dialog
            title="添加用户角色信息"
            :visible.sync="dialogVisible"
            width="50%"
            @close="closeDialog"
            >
                <el-form :model="ruleForm" :rules="rules" ref="ruleFormRef" label-width="80px">
                    <el-form-item label="角色名称" prop="roleName">
                        <el-input type="text" v-model="ruleForm.roleName"></el-input>
                    </el-form-item>
                    <el-form-item label="角色描述" prop="roleDesc">
                        <el-input type="text" v-model="ruleForm.roleDesc"></el-input>
                    </el-form-item>
                </el-form>
                <span slot="footer" class="dialog-footer">
                    <el-button @click="dialogVisible = false">取 消</el-button>
                    <el-button type="primary" @click="addUser">确 定</el-button>
                </span>
        </el-dialog>

        <el-dialog
        title="修改用户角色信息"
        :visible.sync="userUpdateFrom"
        width="50%"
        @close="closeEditFrom"
        >
            <el-form :model="editFrom" :rules="editFromRules" ref="editFromRef" label-width="80px">
                <el-form-item label="角色名称" prop="roleName">
                    <el-input type="text" v-model="editFrom.roleName"></el-input>
                </el-form-item>
                <el-form-item label="角色描述" prop="roleDesc">
                    <el-input type="text" v-model="editFrom.roleDesc"></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="userUpdateFrom = false">取 消</el-button>
                <el-button type="primary" @click="editUser">确 定</el-button>
            </span>
        </el-dialog>

        <el-dialog
        title="角色分配"
        :visible.sync="setRightDialog"
        width="50%"
        @close="setRightDialogClosed">
            <el-tree 
            :data="rightslist" 
            :props="treeProps" 
            show-checkbox node-key="id"
            :default-checked-keys="defKeys"
            ref="treeRef"></el-tree>
            <span slot="footer" class="dialong-footer">
                <el-button @click="setRightDialogV = false" >
                    取消
                </el-button>
                <el-button type="primary" @click="allotRIght">
                    确定
                </el-button>
            </span>
        </el-dialog>
  </div>
</template>

<script>
export default {
    data(){
        return{
            queryInfo: {
                query: '',
                pagenum: 2,
                pagesize: 4
            },
            total: 0,
            rolesList: [],
            editFrom:{},
            dialogVisible: false,
            userUpdateFrom: false,
            setRightDialog: false,
            // 默认选中的
            roleId: '',
            defKeys:[
            ],
            rightslist: '',
            // 树形控件属性绑定对象
            treeProps:{
                label: 'authName',
                children: 'children',
            },
            ruleForm: {
                roleName: '',
                roleDesc: ''
            },
            rules:{
                roleName:[
                    { required: true, message: '请输入角色名称', trigger: 'blur' },
                    { min: 0, max: 10, message: '长度在 0 到 10 个字符', trigger: 'blur' }
                ]
            },
            editFromRules:{
                roleName:[
                    { required: true, message: '请输入角色名称', trigger: 'blur' },
                    { min: 0, max: 10, message: '长度在 0 到 10 个字符', trigger: 'blur' }
                ]
            }
        }
    },
    created(){
        this.getRolesList()
    },
    methods: {
        async getRolesList(){
            const {data:res} =await this.$http.get('roles')
            console.log(res);
            if(res.meta.status !== 200) return this.$$message.error("获取失败")
            this.rolesList = res.data
        },
        // 监听分页数据
        handleSizeChange(newSzie){
            // console.log(newSzie);
            this.queryInfo.pagesize = newSzie
            this.getRolesList()
        },
        // 监听页码只改变事件
        handleCurrentChange(newPage){
            // console.log(newPage);
            this.queryInfo.pagenum = newPage
            this.getRolesList()
        },
        addUser(){
            this.$refs.ruleFormRef.validate(async val => {
                // console.log(val);
                if(!val) return
                const {data:res} = await this.$http.post('roles', this.ruleForm)
                console.log(res);
                if(res.meta.status !== 201) return this.$message.error("添加角色失败")
                this.$message.success("添加角色成功")
                this.dialogVisible = false
                this.getRolesList()
            })
        },
        closeDialog(){
            this.$refs.ruleFormRef.resetFields()
        },
        async showUserFrom(id){
            this.userUpdateFrom = true
            const {data:res} = await this.$http.get('roles/' + id )
            
            if(res.meta.status !== 200) {return this.$message.error("用户信息获取失败")}
            console.log(res);
    
            this.editFrom = res.data

        },
        // 修改用户信息校验
        editUser(){
            this.$refs.editFromRef.validate(async val => {
                console.log(val);
                if(!val) return
                // 验证通过,开始添加请求
                const {data:res} = await this.$http.put('roles/' + this.editFrom.id , this.editFrom)
                console.log(res);
                if(res.meta.status !== 400) return this.$message.error("用户信息请求失败")
                this.$message.success("用户信息修改成功")
                this.userUpdateFrom = false
                this.getRolesList()

            })
        },
        closeEditFrom(){
            this.$refs.editFromRef.resetFields()
        },
        // 根据id删除用户
        async removeUser(id){
            const res = await this.$confirm(
                "确定要删除用户吗?", 
                '提示', 
                {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
                },
                console.log(res)
            ).catch( err => err)  //省略return需要省略{}
            
            // confirm确认   cancle取消
            if(res !== "confirm") {
                return this.$message.info("已取消删除用户信息")
            } else {
                const {data:delUser} = await this.$http.delete('roles/' + id)
                if(delUser.meta.status !== 200) return this.$message.error("用户信息删除失败")
                this.$message.success("用户信息删除成功")
                this.getRolesList()
            }
        },
        async removeById(role,rightId){
            const confirmResult = await this.$confirm('此操作将永久删除该文件, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
            }).catch(err => err)
            if(confirmResult !== 'confirm') return this.$message.error("取消删除")
            // console.log("确认删除");
            const {data:res} = await this.$http.delete(`roles/${role.id}/rights/${rightId}`)
            console.log(res);
            if(res.meta.status !== 200) return this.$message.error("删除失败")
            // this.getRolesList()
            role.children = res.data
        },
        async setRightDialogV(role){
            this.roleId = role.id
            const {data:res} = await this.$http.get('rights/tree')
            if(res.meta.status !== 200) return this.$message.error("获取权限数据失败")

            // 把获取的权限数据保存到data中
            this.rightslist = res.data
            console.log(this.rightslist);
            this.getLeafKeys(role, this.defKeys)
            this.setRightDialog = true
        },
        setRightDialogClosed(){
            this.defKeys = []
        },
        // 通过递归形式获取角色下所有三级权限的ID并保存到数组defKeys[]
        // 如果当前node节点不包含children属性，则是三级节点
        getLeafKeys(node, arr){
            if(!node.children){
                return arr.push(node.id)
            } 
            node.children.forEach( item =>{
                this.getLeafKeys(item, arr)
            })
        },
        async allotRIght(){
            const keys = [
            ...this.$refs.treeRef.getCheckedKeys(),
            ...this.$refs.treeRef.getHalfCheckedKeys()
            ]
            console.log(keys);
            const idStr = keys.join(',')
            const {data:res} = await this.$http.post(`roles/${this.roleId}/rights`, {rids:idStr})
            if(res.meta.status !== 200) return this.$message.error("分配权限失败!")
            this.$message.success("分配权限成功!")
            this.getRolesList()
            this.setRightDialog = false
        }
    }
}
</script>

<style scoped>
.el-tag {
    margin: 7px;
}
.bdtop {
    border-top: 1px solid #eee;
}
.bdbottom {
    border-bottom: 1px solid #eee;
}
.vcenter {
    display: flex;
    align-items: center;
}
</style>